Index: java/main/src/main/java/com/framsticks/hosting/ServerInstance.java
===================================================================
--- java/main/src/main/java/com/framsticks/hosting/ServerInstance.java	(revision 87)
+++ java/main/src/main/java/com/framsticks/hosting/ServerInstance.java	(revision 88)
@@ -4,9 +4,11 @@
 import com.framsticks.params.ConstructionException;
 import com.framsticks.params.FramsClass;
-import com.framsticks.params.Param;
 import com.framsticks.core.LocalInstance;
+import com.framsticks.util.dispatching.Dispatching;
 import com.framsticks.util.dispatching.Future;
+import com.framsticks.util.dispatching.Joinable;
+import com.framsticks.util.dispatching.JoinableParent;
+import com.framsticks.util.dispatching.JoinableState;
 
-import org.apache.commons.configuration.Configuration;
 import org.apache.log4j.Logger;
 
@@ -14,5 +16,5 @@
  * @author Piotr Sniegowski
  */
-public class ServerInstance extends LocalInstance {
+public class ServerInstance extends LocalInstance implements JoinableParent {
 
 	private final static Logger log = Logger.getLogger(ServerInstance.class.getName());
@@ -24,24 +26,24 @@
 
 	@Override
-	protected void run() {
-		super.run();
+	protected void firstTask() {
+		super.firstTask();
 		assert hosted != null;
-		hosted.start();
+		Dispatching.use(hosted, this);
 	}
 
-	@Override
-	public void configure(Configuration config) {
-		super.configure(config);
+	// @Override
+	// public void configure(Configuration config) {
+	//	super.configure(config);
 
-		Configuration hostedConfig = config.subset("hosted.entity");
-		hosted = Program.configureEntity(hostedConfig);
-		if (hosted == null) {
-			log.fatal("failed to create hosted entity");
-			return;
-		}
-		hosted.setName("hosted");
-		hosted.configure(hostedConfig);
-		root = new Node(Param.build().name("root").id("root").type("o" + hosted.getClass().getCanonicalName()), hosted);
-	}
+	//	Configuration hostedConfig = config.subset("hosted.entity");
+	//	hosted = Program.configureEntity(hostedConfig);
+	//	if (hosted == null) {
+	//		log.fatal("failed to create hosted entity");
+	//		return;
+	//	}
+	//	hosted.setName("hosted");
+	//	hosted.configure(hostedConfig);
+	//	root = new Node(Param.build().name("root").id("root").type("o" + hosted.getClass().getCanonicalName()), hosted);
+	// }
 
 	@Override
@@ -93,3 +95,19 @@
 	}
 
+	@Override
+	public void childChangedState(Joinable joinable, JoinableState state) {
+		proceedToState(state);
+
+	}
+
+	@Override
+	protected void joinableInterrupt() {
+		Dispatching.drop(hosted, this);
+	}
+
+	@Override
+	protected void joinableFinish() {
+
+	}
+
 }
Index: java/main/src/main/java/com/framsticks/leftovers/FavouritesXMLFactory.java
===================================================================
--- java/main/src/main/java/com/framsticks/leftovers/FavouritesXMLFactory.java	(revision 87)
+++ java/main/src/main/java/com/framsticks/leftovers/FavouritesXMLFactory.java	(revision 88)
@@ -3,6 +3,9 @@
 import java.io.BufferedWriter;
 import java.io.File;
+import java.io.FileInputStream;
+import java.io.FileNotFoundException;
 import java.io.FileOutputStream;
 import java.io.IOException;
+import java.io.InputStream;
 import java.io.OutputStreamWriter;
 import java.nio.file.Files;
@@ -26,4 +29,5 @@
 import org.xml.sax.SAXException;
 
+import com.framsticks.util.FramsticksException;
 import com.framsticks.util.io.Encoding;
 
@@ -36,20 +40,25 @@
 	private static final String TYPE_MARK = "type";
 
-	protected Node readDocument(String filename) {
+	public static Node readDocument(InputStream stream) {
+		DocumentBuilderFactory docBuilderFactory = DocumentBuilderFactory.newInstance();
+		try {
+			DocumentBuilder docBuilder = docBuilderFactory.newDocumentBuilder();
+			Document doc = docBuilder.parse(stream);
+			doc.getDocumentElement().normalize();
+			return doc.getFirstChild();
+		} catch (ParserConfigurationException | SAXException | IOException e) {
+			throw new FramsticksException().cause(e);
+		}
+	}
+
+	public static Node readDocument(String filename) {
 		File file = new File(filename);
 		if (!file.exists()) {
-			return null;
-		}
-		DocumentBuilderFactory docBuilderFactory = DocumentBuilderFactory
-				.newInstance();
+			throw new FramsticksException().msg("file does not exist");
+		}
 		try {
-			DocumentBuilder docBuilder = docBuilderFactory.newDocumentBuilder();
-			Document doc = docBuilder.parse(file);
-			doc.getDocumentElement().normalize();
-			return doc.getFirstChild();
-
-		} catch (ParserConfigurationException | SAXException | IOException e) {
-			log.error(e);
-			return null;
+			return readDocument(new FileInputStream(file));
+		} catch (FileNotFoundException e) {
+			throw new FramsticksException().cause(e);
 		}
 	}
Index: java/main/src/main/java/com/framsticks/model/f0/NeuroClass.java
===================================================================
--- java/main/src/main/java/com/framsticks/model/f0/NeuroClass.java	(revision 88)
+++ java/main/src/main/java/com/framsticks/model/f0/NeuroClass.java	(revision 88)
@@ -0,0 +1,84 @@
+package com.framsticks.model.f0;
+
+import java.util.ArrayList;
+import java.util.Collections;
+import java.util.List;
+
+import javax.annotation.concurrent.Immutable;
+
+import com.framsticks.params.FramsClass;
+import com.framsticks.params.annotations.FramsClassAnnotation;
+
+import static com.framsticks.util.Misc.throwIfNull;
+import static com.framsticks.util.Misc.returnNotNull;
+
+@Immutable
+@FramsClassAnnotation(id = "neuroclass", name = "neuroclass")
+public class NeuroClass extends FramsClass {
+
+
+	public NeuroClass(NeuroClassBuilder builder) {
+		super(builder);
+
+		preferredInputs = throwIfNull(builder.getPreferredInputs());
+		preferredOutput = throwIfNull(builder.getPreferredOutput());
+		preferredLocation = throwIfNull(builder.getPreferredLocation());
+		visualHints = returnNotNull(builder.getVisualHints(), 0);
+
+		if (builder.getSymbolGlyph() != null) {
+			symbolGlyph = new ArrayList<>();
+			for (String s : builder.getSymbolGlyph().split(",")) {
+				symbolGlyph.add(Integer.valueOf(s));
+			}
+		} else {
+			symbolGlyph = null;
+		}
+
+	}
+
+	protected final int preferredInputs;
+
+	protected final int preferredOutput;
+
+	protected final int preferredLocation;
+
+	protected final int visualHints;
+
+	protected final List<Integer> symbolGlyph;
+
+	/**
+	 * @return the preferredInputs
+	 */
+	public int getPreferredInputs() {
+		return preferredInputs;
+	}
+
+	/**
+	 * @return the preferredOutput
+	 */
+	public int getPreferredOutput() {
+		return preferredOutput;
+	}
+
+	/**
+	 * @return the preferredLocation
+	 */
+	public int getPreferredLocation() {
+		return preferredLocation;
+	}
+
+	/**
+	 * @return the visualHints
+	 */
+	public int getVisualHints() {
+		return visualHints;
+	}
+
+	/**
+	 * @return the symbolGlyph
+	 */
+	public List<Integer> getSymbolGlyph() {
+		return Collections.unmodifiableList(symbolGlyph);
+	}
+
+}
Index: java/main/src/main/java/com/framsticks/model/f0/NeuroClassBuilder.java
===================================================================
--- java/main/src/main/java/com/framsticks/model/f0/NeuroClassBuilder.java	(revision 88)
+++ java/main/src/main/java/com/framsticks/model/f0/NeuroClassBuilder.java	(revision 88)
@@ -0,0 +1,130 @@
+package com.framsticks.model.f0;
+
+import com.framsticks.params.FramsClassBuilder;
+import com.framsticks.params.annotations.FramsClassAnnotation;
+import com.framsticks.params.annotations.ParamAnnotation;
+
+@FramsClassAnnotation(id = "neuroclass", name = "neuroclass")
+public class NeuroClassBuilder extends FramsClassBuilder {
+
+	/**
+	 *
+	 */
+	public NeuroClassBuilder() {
+		super();
+	}
+
+	protected Integer preferredInputs;
+
+	protected Integer preferredOutput;
+
+	protected Integer preferredLocation;
+
+	protected Integer visualHints;
+
+	protected String symbolGlyph;
+
+	/** That method is just an alias needed by f0def.xml in current shape.
+	 *
+	 */
+	@ParamAnnotation(id = "description")
+	public NeuroClassBuilder descriptionAlias(String description) {
+		description(description);
+		return this;
+	}
+
+	/** That method is just an alias needed by f0def.xml in current shape.
+	 *
+	 */
+	@ParamAnnotation(id = "description")
+	public String descriptionAlias() {
+		return description;
+	}
+
+	@Override
+	public NeuroClass finish() {
+		return new NeuroClass(this);
+	}
+
+	/**
+	 * @return the preferredInputs
+	 */
+	@ParamAnnotation(id = "inputs")
+	public Integer getPreferredInputs() {
+		return preferredInputs;
+	}
+
+	/**
+	 * @param preferredInputs the preferredInputs to set
+	 */
+	@ParamAnnotation(id = "inputs")
+	public void setPreferredInputs(Integer preferredInputs) {
+		this.preferredInputs = preferredInputs;
+	}
+
+	/**
+	 * @return the preferredOutput
+	 */
+	@ParamAnnotation(id = "output")
+	public Integer getPreferredOutput() {
+		return preferredOutput;
+	}
+
+	/**
+	 * @param preferredOutput the preferredOutput to set
+	 */
+	@ParamAnnotation(id = "output")
+	public void setPreferredOutput(Integer preferredOutput) {
+		this.preferredOutput = preferredOutput;
+	}
+
+	/**
+	 * @return the preferredLocation
+	 */
+	@ParamAnnotation(id = "location")
+	public Integer getPreferredLocation() {
+		return preferredLocation;
+	}
+
+	/**
+	 * @param preferredLocation the preferredLocation to set
+	 */
+	@ParamAnnotation(id = "location")
+	public void setPreferredLocation(Integer preferredLocation) {
+		this.preferredLocation = preferredLocation;
+	}
+
+	/**
+	 * @return the visualHints
+	 */
+	@ParamAnnotation(id = "visualhints")
+	public Integer getVisualHints() {
+		return visualHints;
+	}
+
+	/**
+	 * @param visualHints the visualHints to set
+	 */
+	@ParamAnnotation(id = "visualhints")
+	public void setVisualHints(Integer visualHints) {
+		this.visualHints = visualHints;
+	}
+
+	/**
+	 * @return the symbolGlyph
+	 */
+	@ParamAnnotation(id = "symbol")
+	public String getSymbolGlyph() {
+		return symbolGlyph;
+	}
+
+	/**
+	 * @param symbolGlyph the symbolGlyph to set
+	 */
+	@ParamAnnotation(id = "symbol")
+	public void setSymbolGlyph(String symbolGlyph) {
+		this.symbolGlyph = symbolGlyph;
+	}
+
+
+}
Index: java/main/src/main/java/com/framsticks/model/f0/NeuroConnection.java
===================================================================
--- java/main/src/main/java/com/framsticks/model/f0/NeuroConnection.java	(revision 88)
+++ java/main/src/main/java/com/framsticks/model/f0/NeuroConnection.java	(revision 88)
@@ -0,0 +1,27 @@
+package com.framsticks.model.f0;
+
+import com.framsticks.params.annotations.FramsClassAnnotation;
+import com.framsticks.params.annotations.ParamAnnotation;
+
+/**
+ * The Class NeuroConnection.
+ */
+@FramsClassAnnotation
+public class NeuroConnection {
+
+	@ParamAnnotation(id = "n1")
+	public Integer thisNeuro;
+
+	@ParamAnnotation(id = "n2")
+	public Integer connectedNeuro;
+
+	@ParamAnnotation(id = "w")
+	public Double weight;
+
+	@ParamAnnotation(id = "i")
+	public String info;
+
+	@ParamAnnotation(id = "Vstyle")
+	public String visStyle;
+
+}
Index: java/main/src/main/java/com/framsticks/model/f0/NeuroParamBuilder.java
===================================================================
--- java/main/src/main/java/com/framsticks/model/f0/NeuroParamBuilder.java	(revision 88)
+++ java/main/src/main/java/com/framsticks/model/f0/NeuroParamBuilder.java	(revision 88)
@@ -0,0 +1,15 @@
+package com.framsticks.model.f0;
+
+import com.framsticks.params.ParamBuilder;
+import com.framsticks.params.annotations.FramsClassAnnotation;
+
+@FramsClassAnnotation(id = "neuroprop", name="neuroprop")
+public class NeuroParamBuilder extends ParamBuilder {
+
+	/**
+	 *
+	 */
+	public NeuroParamBuilder() {
+	}
+
+}
Index: java/main/src/main/java/com/framsticks/model/f0/Schema.java
===================================================================
--- java/main/src/main/java/com/framsticks/model/f0/Schema.java	(revision 88)
+++ java/main/src/main/java/com/framsticks/model/f0/Schema.java	(revision 88)
@@ -0,0 +1,96 @@
+package com.framsticks.model.f0;
+
+import java.io.InputStream;
+import java.util.Set;
+
+import com.framsticks.params.*;
+import com.framsticks.params.annotations.AutoAppendAnnotation;
+import com.framsticks.params.annotations.FramsClassAnnotation;
+import com.framsticks.parsers.XmlLoader;
+import com.framsticks.util.DoubleMap;
+import com.framsticks.util.FramsticksException;
+
+import com.framsticks.model.Package;
+
+/**
+ * The Class Schema, which represent f0 schema (it contains all the possible
+ * classes definitions that can be used in f0 representation). Definitions are
+ * loaded from XML stream.
+ *
+ * @author Jarek Szymczak <name.surname@gmail.com>
+ * (please replace name and surname with my personal data)
+ */
+@FramsClassAnnotation(id = "f0classes", name = "f0classes")
+public class Schema {
+
+	protected final Registry registry = new Registry();
+
+	/** The neuro classes (classess representing different types of neurons). */
+	private DoubleMap<String, FramsClass> framsClasses = new DoubleMap<>();
+	private DoubleMap<String, NeuroClass> neuroClasses = new DoubleMap<>();
+
+	public static InputStream getDefaultDefinitionAsStream() {
+		//return new FileInputStream(new File(Schema.class.getResource("/parsers/f0def.xml").getPath()));
+		return Schema.class.getResourceAsStream("/parsers/f0def.xml");
+	}
+
+	public static Schema load(InputStream stream) {
+
+		XmlLoader xmlLoader = new XmlLoader();
+		xmlLoader.setUseLowerCase(true);
+		xmlLoader.getRegistry()
+			.registerAndBuild(Schema.class)
+			.registerAndBuild(FramsClassBuilder.class)
+			.registerAndBuild(NeuroClassBuilder.class)
+			.registerAndBuild(ParamBuilder.class)
+			.registerAndBuild(NeuroParamBuilder.class)
+			.registerAndBuild(GroupBuilder.class)
+			;
+
+		Package.register(xmlLoader.getRegistry());
+
+		Object object = xmlLoader.load(Schema.getDefaultDefinitionAsStream());
+		if (!(object instanceof Schema)) {
+			throw new FramsticksException().msg("failed to load schema");
+		}
+		return (Schema) object;
+	}
+
+	public Schema() {
+	}
+
+	public void addClass(FramsClass framsClass) {
+		registry.putInfoIntoCache(framsClass);
+		if (framsClass instanceof NeuroClass) {
+			neuroClasses.put(framsClass.getId(), framsClass.getName(), (NeuroClass) framsClass);
+			return;
+		}
+		framsClasses.put(framsClass.getId(), framsClass.getName(), framsClass);
+	}
+
+	@AutoAppendAnnotation
+	public void addClass(FramsClassBuilder builder) {
+		addClass(builder.finish());
+	}
+
+	public Set<NeuroClass> getNeuroClasses() {
+		return neuroClasses.getValues();
+	}
+
+	public Set<FramsClass> getFramsClasses() {
+		return framsClasses.getValues();
+	}
+
+	public NeuroClass getNeuroClass(String identifier) {
+		return neuroClasses.get(identifier);
+	}
+
+	public FramsClass getFramsClass(String identifier) {
+		return framsClasses.get(identifier);
+	}
+
+	public final Registry getRegistry() {
+		return registry;
+	}
+
+}
Index: java/main/src/main/java/com/framsticks/model/f0/VisualHints.java
===================================================================
--- java/main/src/main/java/com/framsticks/model/f0/VisualHints.java	(revision 88)
+++ java/main/src/main/java/com/framsticks/model/f0/VisualHints.java	(revision 88)
@@ -0,0 +1,28 @@
+package com.framsticks.model.f0;
+
+/**
+ * The Class with VisualHints constants.
+ */
+public final class VisualHints {
+
+	/** don't draw class name label below the neuron. */
+	public static final int DONT_SHOW_CLASS = 2;
+	
+	/** draw the neuron at the first part when attached to joint (default is in the middle). */
+	public static final int AT_FIRST_PART = 4;
+	
+	/** draw the neuron at the second part when attached to joint (default is in the middle). */
+	public static final int AT_SECOND_PART = 8;
+	
+	/** use effector color for this neuro unit. */
+	public static final int EFFECTOR_CLASS = 16;
+	
+	/** use receptor color for this neuro unit. */
+	public static final int RECEPTOR_CLASS = 32;
+	
+	/** The Constant V1_BEND_MUSCLE. */
+	public static final int V1_BEND_MUSCLE = 64;
+	
+	/** The Constant V1_ROT_MUSCLE. */
+	public static final int V1_ROT_MUSCLE = 128;
+}
Index: java/main/src/main/java/com/framsticks/params/FramsClass.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/FramsClass.java	(revision 87)
+++ java/main/src/main/java/com/framsticks/params/FramsClass.java	(revision 88)
@@ -3,4 +3,5 @@
 import com.framsticks.params.annotations.FramsClassAnnotation;
 import com.framsticks.params.annotations.ParamAnnotation;
+import com.framsticks.util.FramsticksException;
 // import com.framsticks.util.FramsticksException;
 
@@ -26,5 +27,5 @@
 @Immutable
 @FramsClassAnnotation(id = "class", name = "class")
-public final class FramsClass {
+public class FramsClass {
 
 	private final static Logger log = Logger.getLogger(FramsClass.class);
@@ -54,13 +55,13 @@
 	}
 
-	public FramsClass(String id, String name, String description, List<Param> params, List<Group> groups) {
+	public FramsClass(FramsClassBuilder builder) {
 
-		this.id = id;
-		this.name = name;
-		this.description = description;
-		this.groups = groups;
-		this.paramList = params;
+		this.id = builder.getId();
+		this.name = builder.getName();
+		this.description = builder.getDescription();
+		this.groups = builder.groups;
+		this.paramList = builder.params;
 
-		for (Param param : params) {
+		for (Param param : paramList) {
 			paramEntryMap.put(param.getId(), param);
 			try {
@@ -133,10 +134,10 @@
 	public <T extends Param> T castedParam(@Nonnull final Param param, @Nonnull final Class<T> type, Object name) {
 		if (param == null) {
-			return null;
-			// throw new FramsticksException().msg("param is missing").arg("name", name).arg("in", this);
+			// return null;
+			throw new FramsticksException().msg("param is missing").arg("name", name).arg("in", this);
 		}
 		if (!type.isInstance(param)) {
-			return null;
-			// throw new FramsticksException().msg("wrong type of param").arg("actual", param.getClass()).arg("requested", type).arg("in", this);
+			// return null;
+			throw new FramsticksException().msg("wrong type of param").arg("actual", param.getClass()).arg("requested", type).arg("in", this);
 		}
 		return type.cast(param);
Index: java/main/src/main/java/com/framsticks/params/FramsClassBuilder.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/FramsClassBuilder.java	(revision 87)
+++ java/main/src/main/java/com/framsticks/params/FramsClassBuilder.java	(revision 88)
@@ -21,8 +21,10 @@
 import com.framsticks.parsers.FileSource;
 import com.framsticks.parsers.Loaders;
+import com.framsticks.util.Builder;
+import com.framsticks.util.FramsticksException;
 import com.framsticks.util.lang.Strings;
 
 @FramsClassAnnotation(id = "class", name = "class")
-public class FramsClassBuilder {
+public class FramsClassBuilder implements Builder<FramsClass> {
 	private static final Logger log =
 		Logger.getLogger(FramsClassBuilder.class);
@@ -163,5 +165,5 @@
 	}
 
-	public static Map<Class<?>, FramsClass> synchronizedCacheForBasedOnForJavaClass = Collections.synchronizedMap(new HashMap<Class<?>, FramsClass>());
+	public static final Map<Class<?>, FramsClass> synchronizedCacheForBasedOnForJavaClass = Collections.synchronizedMap(new HashMap<Class<?>, FramsClass>());
 
 	public FramsClass forClass(Class<?> javaClass) throws ConstructionException {
@@ -171,5 +173,5 @@
 		}
 
-		log.info("building for class " + javaClass);
+		log.debug("building for class " + javaClass);
 
 		FramsClassAnnotation fca = javaClass.getAnnotation(FramsClassAnnotation.class);
@@ -184,5 +186,9 @@
 
 		for (ParamCandidate pc : candidates.values()) {
-			param(Param.build().id(pc.getId()).name(pc.getName()).type(getParamTypeForNativeType(pc.getType())).flags(pc.getFlags()));
+			String type = getParamTypeForNativeType(pc.getType());
+			if (type == null) {
+				throw new FramsticksException().msg("failed to find type for param candidate").arg("candidate", pc);
+			}
+			param(Param.build().id(pc.getId()).name(pc.getName()).type(type).flags(pc.getFlags()));
 		}
 
@@ -233,5 +239,5 @@
 
 	public FramsClass finish() {
-		return new FramsClass(id, name, description, params, groups);
+		return new FramsClass(this);
 	}
 
@@ -244,4 +250,9 @@
 	public FramsClassBuilder param(ParamBuilder builder) {
 		return append(builder.finish());
+	}
+
+	@AutoAppendAnnotation
+	public FramsClassBuilder group(GroupBuilder builder) {
+		return group(builder.finish());
 	}
 
Index: java/main/src/main/java/com/framsticks/params/GroupBuilder.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/GroupBuilder.java	(revision 88)
+++ java/main/src/main/java/com/framsticks/params/GroupBuilder.java	(revision 88)
@@ -0,0 +1,26 @@
+package com.framsticks.params;
+
+import com.framsticks.params.annotations.FramsClassAnnotation;
+import com.framsticks.params.annotations.ParamAnnotation;
+
+@FramsClassAnnotation(id = "group", name = "group")
+public class GroupBuilder {
+
+	@ParamAnnotation
+	protected String name;
+
+	public GroupBuilder() {
+	}
+
+	@ParamAnnotation
+	public GroupBuilder name(String name) {
+		this.name = name;
+		return this;
+	}
+
+	public Group finish() {
+		return new Group(name);
+	}
+
+
+}
Index: java/main/src/main/java/com/framsticks/params/Param.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/Param.java	(revision 87)
+++ java/main/src/main/java/com/framsticks/params/Param.java	(revision 88)
@@ -53,5 +53,5 @@
 		group = builder.getGroup();
 		flags = builder.getFlags();
-		extra = 0;
+		extra = builder.getExtra();
 	}
 
Index: java/main/src/main/java/com/framsticks/params/ParamBuilder.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/ParamBuilder.java	(revision 87)
+++ java/main/src/main/java/com/framsticks/params/ParamBuilder.java	(revision 88)
@@ -4,4 +4,5 @@
 import com.framsticks.params.annotations.ParamAnnotation;
 import com.framsticks.params.types.*;
+import com.framsticks.util.Builder;
 import com.framsticks.util.FramsticksException;
 import com.framsticks.util.lang.Strings;
@@ -23,5 +24,5 @@
 
 @FramsClassAnnotation(name = "prop", id = "prop")
-public class ParamBuilder {
+public class ParamBuilder implements Builder<Param> {
 	private final static Logger log = Logger.getLogger(ParamBuilder.class.getName());
 
@@ -63,5 +64,9 @@
 	private Object def;
 
+	private Integer extra;
+
 	String containedTypeName;
+
+	protected Class<?> storageType;
 
 	protected FramsClassBuilder classBuilder;
@@ -83,4 +88,5 @@
 	 * @return the min
 	 */
+	@ParamAnnotation
 	public Object getMin() {
 		return min;
@@ -90,4 +96,5 @@
 	 * @return the max
 	 */
+	@ParamAnnotation
 	public Object getMax() {
 		return max;
@@ -97,4 +104,5 @@
 	 * @return the def
 	 */
+	@ParamAnnotation
 	public Object getDef() {
 		return def;
@@ -135,6 +143,10 @@
 	public Param finish() {
 		try {
+			if (paramType == null) {
+				throw new FramsticksException().msg("trying to finish incomplete param");
+			}
+
 			return paramType.getConstructor(ParamBuilder.class).newInstance(this);
-		} catch (InstantiationException | IllegalAccessException | IllegalArgumentException | InvocationTargetException | NoSuchMethodException | SecurityException e) {
+		} catch (InstantiationException | IllegalAccessException | IllegalArgumentException | InvocationTargetException | NoSuchMethodException | SecurityException | FramsticksException e) {
 			throw new FramsticksException().msg("failed to create param").cause(e).arg("name", name);
 		}
@@ -219,4 +231,5 @@
 	public ParamBuilder type(String type) {
 		// typeString = type;
+		assert type != null;
 
 		log.trace("parsing type: " + type);
@@ -352,4 +365,9 @@
 	}
 
+	@ParamAnnotation(id = "xtra")
+	public Integer getExtra() {
+		return extra;
+	}
+
 	/**
 	 * @return the paramType
@@ -359,4 +377,11 @@
 	}
 
+	@ParamAnnotation(id = "xtra")
+	public ParamBuilder extra(Integer extra) {
+		this.extra = extra;
+		return this;
+	}
+
+	@ParamAnnotation
 	public ParamBuilder min(Object min) {
 		this.min = min;
@@ -364,4 +389,5 @@
 	}
 
+	@ParamAnnotation
 	public ParamBuilder max(Object max) {
 		this.max = max;
@@ -369,4 +395,5 @@
 	}
 
+	@ParamAnnotation
 	public ParamBuilder def(Object def) {
 		this.def = def;
@@ -374,8 +401,4 @@
 	}
 
-	// public Class<?> getStorageType() {
-	//	assert param != null;
-	//	return param.getStorageType();
-	// }
 
 	public Param build(String line) throws Exception {
@@ -435,5 +458,5 @@
 	}
 
-	public ParamBuilder defaultDef(Object def) {
+	public ParamBuilder fillDef(Object def) {
 		if (this.def == null) {
 			return def(def);
@@ -442,3 +465,15 @@
 	}
 
+	public ParamBuilder fillStorageType(Class<?> storageType) {
+		if (this.storageType == null) {
+			this.storageType = storageType;
+		}
+		return this;
+	}
+
+
+	public Class<?> getStorageType() {
+		return storageType;
+	}
 }
+
Index: java/main/src/main/java/com/framsticks/params/ParamCandidate.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/ParamCandidate.java	(revision 87)
+++ java/main/src/main/java/com/framsticks/params/ParamCandidate.java	(revision 88)
@@ -132,5 +132,5 @@
 				return;
 			}
-			if (field.has()) {
+			if (isPublic(field)) {
 				if (setter.has()) {
 					throw new ConstructionException().msg("setter and field coexist");
@@ -138,6 +138,6 @@
 			}
 
-			if (getter.get() == null) {
-				throw new ConstructionException().msg("missing getter");
+			if (!getter.has() && !field.has()) {
+				throw new ConstructionException().msg("missing getter or field");
 			}
 		} catch (ConstructionException e) {
@@ -211,5 +211,5 @@
 	@Override
 	public String toString() {
-		return id;
+		return id + "(" + type.toString() + ")";
 	}
 
Index: java/main/src/main/java/com/framsticks/params/PrimitiveParam.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/PrimitiveParam.java	(revision 87)
+++ java/main/src/main/java/com/framsticks/params/PrimitiveParam.java	(revision 88)
@@ -2,4 +2,5 @@
 
 import com.framsticks.util.FramsticksException;
+import com.framsticks.util.Misc;
 import com.framsticks.util.lang.Numbers;
 
@@ -26,7 +27,8 @@
 	public PrimitiveParam(ParamBuilder builder) {
 		super(builder);
-		min = builder.getMin();
-		max = builder.getMax();
-		def = builder.getDef();
+		Class<?> storageType = Misc.returnNotNull(builder.getStorageType(), Object.class);
+		min = tryCastAndReturn(builder.getMin(), storageType);
+		max = tryCastAndReturn(builder.getMax(), storageType);
+		def = tryCastAndReturn(builder.getDef(), storageType);
 	}
 
Index: java/main/src/main/java/com/framsticks/params/ReflectionAccess.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/ReflectionAccess.java	(revision 87)
+++ java/main/src/main/java/com/framsticks/params/ReflectionAccess.java	(revision 88)
@@ -6,4 +6,6 @@
 import java.util.Collections;
 import java.util.HashMap;
+import java.util.LinkedList;
+import java.util.List;
 import java.util.Map;
 
@@ -37,5 +39,5 @@
 	public static class Backend {
 
-		protected static Map<Pair<Class<?>, FramsClass>, Backend> synchronizedCache = Collections.synchronizedMap(new HashMap<Pair<Class<?>, FramsClass>, Backend>());
+		protected static final Map<Pair<Class<?>, FramsClass>, Backend> synchronizedCache = Collections.synchronizedMap(new HashMap<Pair<Class<?>, FramsClass>, Backend>());
 
 		public static class ReflectedValueParam {
@@ -53,10 +55,10 @@
 
 		protected final Map<ValueParam, ReflectedValueParam> params;
-		protected final Map<Class<?>, Method> autoAppendMethods;
+		protected final List<Method> autoAppendMethods;
 
 		/**
 		 * @param params
 		 */
-		public Backend(Map<ValueParam, ReflectedValueParam> params, Map<Class<?>, Method> autoAppendMethods) {
+		public Backend(Map<ValueParam, ReflectedValueParam> params, List<Method> autoAppendMethods) {
 			// this.params = Collections.unmodifiableMap(params);
 			this.params = params;
@@ -140,5 +142,5 @@
 			}
 
-			Map<Class<?>, Method> autoAppendMethods = new HashMap<>();
+			List<Method> autoAppendMethods = new LinkedList<>();
 
 			Class<?> javaClass = reflectedClass;
@@ -154,5 +156,5 @@
 						throw new ConstructionException().msg("invalid number of arguments in AutoAppend marked method").arg("method", m).arg("arguments", args.length);
 					}
-					autoAppendMethods.put(args[0], m);
+					autoAppendMethods.add(m);
 				}
 
@@ -327,11 +329,11 @@
 	public boolean tryAutoAppend(Object value) {
 		assert object != null;
-		for (Map.Entry<Class<?>, Method> a : backend.autoAppendMethods.entrySet()) {
-			if (a.getKey().isAssignableFrom(value.getClass())) {
+		for (Method m : backend.autoAppendMethods) {
+			if (m.getParameterTypes()[0].isAssignableFrom(value.getClass())) {
 				try {
-					a.getValue().invoke(object, value);
+					m.invoke(object, value);
 					return true;
-				} catch (IllegalAccessException | IllegalArgumentException | InvocationTargetException e) {
-					throw new FramsticksException().msg("failed to auto append").cause(e).arg("value", value).arg("into object", object).arg("with method", a.getValue());
+				} catch (IllegalAccessException | IllegalArgumentException | InvocationTargetException | FramsticksException e) {
+					throw new FramsticksException().msg("failed to auto append").cause(e).arg("value", value).arg("into object", object).arg("with method", m);
 				}
 			}
